<?php

namespace Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CustomizationFilesFactory
{
    use TQuery;
    private $connection;

    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getPais()
    {
        $conditions = '';
        $sql = "SELECT *
		  FROM ( SELECT P.CDPAIS, P.NMPAIS, P.NRORG, P.CDESOCIAL,
                   CASE WHEN P.NMPAIS LIKE 'Brasil' THEN 1 ELSE 2 END AS ORDPAIS
                   FROM PAIS P
                  ORDER BY ORDPAIS, NMPAIS)
         WHERE 1=1
		       $conditions";
  
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEstado($idPais){
        $conditions = '';
        $sql = "SELECT *
		  FROM ( SELECT E.SGESTADO, E.NMESTADO, E.CDPAIS
                   FROM ESTADO E
                  WHERE E.CDPAIS = :CDPAIS
               ORDER BY E.NMESTADO)
         WHERE 1=1
		       $conditions";

        $params = array(
            "CDPAIS" => $idPais
        );

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getMunicipio($sigla){
        $conditions = '';
        $sql = "SELECT *
		  FROM ( SELECT M.CDMUNICIPIO, M.NMMUNICIPIO, M.SGESTADO AS STATE_SYMBOL
                   FROM MUNICIPIO M
                  WHERE M.SGESTADO = :SGESTADO
               ORDER BY M.NMMUNICIPIO )
         WHERE 1=1
		 $conditions
        ";

        $params = array(
            "SGESTADO" => $sigla
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getUseLicense($cdCliente)
    {
        $sql = "SELECT CDLINPCLIE,NMLINPCLIE,IDMPROCLINPC,IDLPROCLINPC,NRUSUALINPC,
                      NRACESLINPC,IDTIPLINPC, (IDMPROCLINPC || '/' || IDLPROCLINPC) AS IDMLPROCLINPC
                  FROM CONTRATOLINP
                  WHERE CDCLIENTE     = :CDCLIENTE
                  AND DTCONTLINPRESC IS NULL
                  ORDER BY CDLINPCLIE  ";

        $params = array(
            'CDCLIENTE' => $cdCliente,
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
}