/*
 @C:\Web_605\Sql\End_Conv\SQLServer\99208_PEDSTPS_Replica_Pedido.SQL

 Descrio:
 Procedure para duplicao de pedidos

  RAISERROR('', 16,1);
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'REPLICA_PEDIDO' AND
	        TYPE = 'P' 			      AND
	        U.UID = O.UID            AND
	        U.NAME = USER)
DROP PROCEDURE REPLICA_PEDIDO
GO

CREATE PROCEDURE REPLICA_PEDIDO @P_CDFILIAL        VARCHAR(04),
                                @P_NRPEDIDONEW     VARCHAR(10),
                                @P_CDCLIENTE       VARCHAR(21),
                                @P_CDFILIDEST      VARCHAR(04),
                                @P_DATAPEDIDO      DATETIME,
                                @P_DATAENTREGA     DATETIME,
                                @P_DATAVALIDADE    DATETIME,
                                @P_NRORDCOMPRA     VARCHAR(15),
                                @P_CDFILIALPEDORIG VARCHAR(04),
                                @P_NRPEDIDO        VARCHAR(10),
                                @P_CDOPERADOR      VARCHAR(12),
                                @P_CDMENSERRO      VARCHAR OUTPUT

AS
   DECLARE @V_CTREGISTRO     INTEGER;

   DECLARE @V_DTENTPED       DATETIME;
   DECLARE @V_DTPEDIDO       DATETIME;
   DECLARE @V_SEQUENCIAL     VARCHAR(20);
   DECLARE @V_NRDIASENTPED   VARCHAR(04);

   DECLARE @V_CDVENDEDOR     VARCHAR(04);
   DECLARE @V_IDLANCPED      VARCHAR(01);
   DECLARE @V_IDUTRESELOTE   VARCHAR(01);
   DECLARE @V_CDTIPOOPER     VARCHAR(02);
   DECLARE @V_IDEXIBIMPITPED VARCHAR(01);
   DECLARE @V_IDSITPEDIDO    VARCHAR(01);


   DECLARE @V_IDTPFORPGTOMOD  VARCHAR(01);
   DECLARE @V_NRDIAPGFIXMOD   INTEGER;
   DECLARE @V_NRPARCPGTOMOD   INTEGER;
   DECLARE @V_CDFORMPGTO      VARCHAR(02);
   DECLARE @V_ERRO            VARCHAR(400);
   DECLARE @V_IDOBRTPOPPED    VARCHAR(01);
   DECLARE @V_CDOPERPED       VARCHAR(02);
   DECLARE @V_CDCLIENTEORIG   VARCHAR(21);
   DECLARE @V_CDMODPGTOORIG   VARCHAR(05);
   DECLARE @V_CDVENDEDORORIG  VARCHAR(04);
   DECLARE @V_CDCLIENTEDEST   VARCHAR(21);
   DECLARE @V_CDMODPGTODEST   VARCHAR(05);
   DECLARE @V_CDVENDEDORDEST  VARCHAR(04);
   DECLARE @V_DTVALIPED       DATETIME;
   DECLARE @V_IDUTVALIPED     VARCHAR(01);
   DECLARE @V_QTDIAVALIPED    DOUBLE PRECISION;
   DECLARE @V_CDROTATRANSPED  VARCHAR(06);
   DECLARE @V_IDORIGDESTOP    VARCHAR(01);
   DECLARE @V_NRINSJURTRAN    VARCHAR(20);
   DECLARE @V_CDTIPTRANS      VARCHAR(04);
   DECLARE @V_IDPGFRETTRA     VARCHAR(01);
   DECLARE @V_CDPRECOBASE     VARCHAR(02);
BEGIN
   SET @P_CDMENSERRO = 'OK';
   SET @V_ERRO = NULL;
   SET @V_CDROTATRANSPED = NULL;
   SET @V_CDPRECOBASE = NULL;


   SELECT @V_CTREGISTRO = ISNULL(COUNT(1), 0)
     FROM PARAMPEDIDO
    WHERE CDFILIAL = @P_CDFILIAL;

   IF (@V_CTREGISTRO = 0) BEGIN
      SET @P_CDMENSERRO = 'FILIAL_N_PARAM';
   END;

   IF (@V_CTREGISTRO > 0) BEGIN
      SELECT @V_CDCLIENTEORIG = MAX(CDCLIENTE), @V_CDMODPGTOORIG = MAX(CDMODPGTO), @V_CDVENDEDORORIG = MAX(CDVENDEDOR), @V_NRDIASENTPED = MAX(NRDIASENTPED),
             @V_IDSITPEDIDO = (CASE MAX(IDLANCPED) WHEN '3' THEN '2' ELSE MAX(IDLANCPED) END), @V_CDTIPOOPER = MAX(CDTIPOOPER), @V_IDOBRTPOPPED = MAX(IDOBRTPOPPED),
             @V_IDUTVALIPED = MAX(IDUTVALIPED), @V_QTDIAVALIPED = MAX(QTDIAVALIPED)
      FROM PARAMPEDIDO
      WHERE CDFILIAL = @P_CDFILIAL;

   END;

   SELECT @V_CDPRECOBASE = MAX(PC.CDPRECOBASE)
     FROM PRECOBASECLI PC
    WHERE (PC.CDCLIENTE    = @P_CDCLIENTE)
      AND (PC.IDPRBASEPRIN = 'S');

   SELECT @V_CDVENDEDOR = MAX(CDVENDEDOR), @V_IDLANCPED = MAX(IDLANCPED), @V_IDUTRESELOTE = MAX(IDUTRESELOTE), @V_CDTIPOOPER = MAX(CDTIPOOPER), @V_IDEXIBIMPITPED = ISNULL(MAX(IDEXIBIMPITPED), 'N')
     FROM PARAMPEDIDO
    WHERE CDFILIAL = @P_CDFILIAL;

   IF (@V_CDVENDEDOR IS NULL) BEGIN
      SET @P_CDMENSERRO = 'VENDEDOR_INF';
   END
   ELSE BEGIN
      IF ((@V_CDTIPOOPER IS NULL) AND (@V_IDEXIBIMPITPED = 'S')) BEGIN
         SET @P_CDMENSERRO = 'TIPOOPER_INF';
      END;
      IF (@V_CDMODPGTOORIG IS NULL) BEGIN
         SET @P_CDMENSERRO = 'MOD_PAGAMENTO';
      END;
   END;

   IF (@P_CDMENSERRO = 'OK') BEGIN
      INSERT INTO PEDIDO
            (CDFILIAL,     NRPEDIDO,     IDSITPEDIDO,   CDCLIENTE,   IDPRIOPED,     DTPEDIDO,
             DTENTPED,     CDMODPGTO,    IDTPFORPGTPED, CDFORMPGTO,  NRDIAPGFIXPED, NRPARCPGTOPED,
             IDTPIJURTRAN, NRINSJURTRAN, CDTIPTRANS, IDPGFRETTRAN, DTHRLANPED,    CDOPELANPED, CDFILIALPED,   CDTIPORECE,
             CDVENDEDOR,   IDENTRSAIDOP, CDTIPOOPER,    CDPRECOBASE, DTVALIPED, CDFILLANCA, CDFILSOLI,
             NRSOLICMP,    CDTIPOEDITAL, CDFILIALORC,   NRORCAEVENTO,  NRSEQORCAEVE,
             CDDEPTO, NREMPENHO, NRSEQDIAPROD, CDROTATRANSPED, NRSEQORCAMENTO, IDPEDREPLICA, NRPEDREPLICA, IDPEDINDUSTRIA,
             NRORDEMCMPPED)
      SELECT @P_CDFILIAL,   @P_NRPEDIDONEW, @V_IDSITPEDIDO,   @P_CDCLIENTE, MAX(IDPRIOPED),     @P_DATAPEDIDO,
             @P_DATAENTREGA,@V_CDMODPGTOORIG,    MAX(IDTPFORPGTPED), MAX(CDFORMPGTO),  MAX(NRDIAPGFIXPED), MAX(NRPARCPGTOPED),
             MAX(IDTPIJURTRAN), MAX(NRINSJURTRAN), MAX(CDTIPTRANS),  MAX(IDPGFRETTRAN),   GETDATE(),      @P_CDOPERADOR, @P_CDFILIDEST,   MAX(CDTIPORECE),
             @V_CDVENDEDOR, MAX(IDENTRSAIDOP), @V_CDTIPOOPER,ISNULL(@V_CDPRECOBASE, MAX(CDPRECOBASE)), @P_DATAVALIDADE, MAX(CDFILLANCA), '',
             '',    MAX(CDTIPOEDITAL), '',   '',  '',
             MAX(CDDEPTO), MAX(NREMPENHO), MAX(NRSEQDIAPROD), MAX(CDROTATRANSPED), MAX(NRSEQORCAMENTO), 'S', @P_NRPEDIDO, MAX(IDPEDINDUSTRIA),
             @P_NRORDCOMPRA
        FROM PEDIDO
       WHERE CDFILIAL = @P_CDFILIALPEDORIG AND
             NRPEDIDO = @P_NRPEDIDO;

   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'REPLICA_PEDIDO','6.05.xxx';
GO
