import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import TekLibComponents from '@zeedhi/tek-lib';
import { ZdAvatar } from '@zeedhi/zd-avatar';
import { Icons } from '@zeedhi/common';
import { KeyMap, Loader } from '@zeedhi/core';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, { controllers, router, config });
Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);
Vue.use(TekLibComponents);

Vue.component('ZdAvatar', ZdAvatar);

vuetify.framework.icons.values = Icons.getIcons() as any;

const appController = Loader.getInstance('AppController');

KeyMap.bind({
  esc: {
    event: () => { appController.escAction(); },
    stop: true,
  },
});
